# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "python_exec_rule-start-process-partial-path"
  languages:
  - "python"
  message: |
    Starting a process with a partial executable path
  patterns:
  - pattern-either:
    - patterns:
      - pattern: "os.popen(...)"
      - pattern-not: "os.popen(\"...\", ...)"
    - patterns:
      - pattern: "os.system(...)"
      - pattern-not: "os.system(\"...\", ...)"
    - patterns:
      - pattern: "os.popen2(...)"
      - pattern-not: "os.popen2(\"...\", ...)"
    - patterns:
      - pattern: "os.popen3(...)"
      - pattern-not: "os.popen3(\"...\", ...)"
    - patterns:
      - pattern: "os.popen4(...)"
      - pattern-not: "os.popen4(\"...\", ...)"
    - patterns:
      - pattern: "popen2.popen2(...)"
      - pattern-not: "popen2.popen2(\"...\", ...)"
    - patterns:
      - pattern: "popen2.popen3(...)"
      - pattern-not: "popen2.popen3(\"...\", ...)"
    - patterns:
      - pattern: "popen2.popen4(...)"
      - pattern-not: "popen2.popen4(\"...\", ...)"
    - patterns:
      - pattern: "popen2.Popen3(...)"
      - pattern-not: "popen2.Popen3(\"...\", ...)"
    - patterns:
      - pattern: "popen2.Popen4(...)"
      - pattern-not: "popen2.Popen4(\"...\", ...)"
    - patterns:
      - pattern: "commands.getoutput(...)"
      - pattern-not: "commands.getoutput(\"...\", ...)"
    - patterns:
      - pattern: "commands.getstatusoutput(...)"
      - pattern-not: "commands.getstatusoutput(\"...\", ...)"
  metadata:
    cwe: "CWE-78"
    owasp:
    - "A1:2017-Injection"
    - "A03:2021-Injection"
    shortDescription: "Improper neutralization of special elements used in an OS Command
      ('OS Command Injection')"
    security-severity: "High"
    category: "security"
  severity: "INFO"
